/*
 * UDPServerThread.java
 *
 * Created on December 5, 2002, 4:47 AM
 */

package RcxCtrl;

import java.net.*;
import java.io.*;

/**
 *
 * @author  haihuihu
 */
public class UDPServerThread extends Thread {
    public static DatagramSocket socket = null;
    public static DatagramPacket packet = null;
    public static byte [] imgBuf = new byte[230400];
    public static byte [] frameBuf = new byte[57600];
    
    /*
    public static void main(String[] args) throws IOException 
    {
        new UDPServerThread().start();
    }  
	*/
    
    public void run() {
		try{
            System.out.println("FrameCallBackThread started");
            socket = new DatagramSocket(7776);
            //byte[] buf = new byte[1024];
            int bytesRecvd;
            int framePos = 0;
            int frameNo = 0;
            DatagramPacket packet;// = new DatagramPacket(buf, buf.length);
            System.out.println("UDP Server listening at port 7776");
            while(true)
			{
                //packet = new DatagramPacket(buf, buf.length);
                packet = new DatagramPacket(imgBuf, framePos, 1024);
                socket.receive(packet);
                bytesRecvd = packet.getLength();
                // assemble frame
                framePos += bytesRecvd;
                //System.out.println(bytesRecvd + "-" + framePos);
                if( bytesRecvd < 1024 ) // file end met
                {
                    //System.out.print("("+bytesRecvd + "=" + framePos+"(" + frameNo + ") ");
                    System.out.print("(" + framePos+"," + frameNo + ")");
                    
                    // Write out the full file
                    
                    File outputFile = new File( (new Integer(frameNo%10).toString() ) + ".jpg");
                    if( outputFile.exists() == false )
                        outputFile.createNewFile();
                    FileOutputStream out = new FileOutputStream(outputFile);
                    out.write(imgBuf, 0, framePos );
                    out.close();
                    
                    //System.arraycopy(imgBuf, 0, frameBuf, 0, framePos);
                    RcxCtrlGUI.gui.UpdateWebImage(frameNo%10);  
                    // Increase frame no and reset the framePos
                    frameNo ++;
                    framePos = 0;
                }
                else
                {   //System.out.print(bytesRecvd + "+");
                }
			}
		}catch( Exception e){
            e.printStackTrace(); 
		}
	}

    
}
